/* 
    snap for Bt848 frame grabber driver

    Copyright (C) 1996,97 Marcus Metzler (mocm@thp.uni-koeln.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 * snap.cc 
 */

#include "snap.h"
#include "TVscreenP.h"  /* let's do it the dirty way first */

#define HEX(N) hex << setw(N) << setfill(int('0')) 
#define DEC(N) dec << setw(N) << setfill(int('0')) 

void snapit(Widget screen, int FULL=0)
{
  char name[80];
  static int number=0;
  unchar *tm;

#ifndef NOCARD

  TVscreenWidget w=(TVscreenWidget) screen;

  if (w->TVscreen.CAP_ON){
    ostrstream oname(name,80);
    oname << "pic" << HEX(3) << number << ".pnm" << char(0);
    ofstream os(name);
    
    int old_bpp=w->TVscreen.wtw.bpp;
    w->TVscreen.wtw.bpp=3;               //always 24bit sample for pnm
    
    int old_width,old_height,old_int;
    if (FULL){
      old_width=w->TVscreen.wtw.width;
      old_height=w->TVscreen.wtw.height;
      old_int=w->TVscreen.wtw.interlace;
      
      w->TVscreen.wtw.width=w->TVscreen.max_width;
      w->TVscreen.wtw.height=w->TVscreen.max_height;
      w->TVscreen.wtw.interlace=1;
    }
    
    ioctl(w->TVscreen.fbttv, BTTV_SETWTW, &(w->TVscreen.wtw));        

    tm=w->TVscreen.TargetMem;
    ioctl(w->TVscreen.fbttv, BTTV_TESTM, &tm);
    
    int width=w->TVscreen.wtw.width;
    int height=w->TVscreen.wtw.height;
    
    
    os << "P6\n" << dec << width << "\n"
      << dec << height << "\n255\n";
    for (int i=0; i<width*height; i++, tm+=3) {
      os.write((tm+2),1);
      os.write((tm+1),1);
      os.write(tm,1);
    }
    os.close();
    number++;
    w->TVscreen.wtw.bpp=old_bpp;
    if (FULL){
      w->TVscreen.wtw.width=    old_width;
      w->TVscreen.wtw.height=    old_height;
      w->TVscreen.wtw.interlace=    old_int;
    }
    ioctl(w->TVscreen.fbttv, BTTV_SETWTW, &(w->TVscreen.wtw));        
    ioctl(w->TVscreen.fbttv, BTTV_CAP_ON, NULL);
  }
#endif
}
  
