/* 
 * Thomas Pantzer: netutils.h, v0.1b  28.1.98 18:6 
 * 
 * 
 * Copyright 1998 by Thomas Pantzer
 * 
 * Permission to use, copy, modify, and distribute this software for noncommercial 
 * use and without fee is hereby granted, provided that the above copyright notice 
 * appear in all copies and that both that copyright notice and this permission 
 * notice appear in supporting documentation, and that the name of the Author not be 
 * used in advertising or publicity pertaining to distribution of the software 
 * without specific, written prior permission. The Author makes no representations about
 * the suitability of this software for any purpose.  It is provided "as is" 
 * without expressed or implied warranty. 
 * 
 * 
 * pantec@aix520.informatik.uni-leipzig.de   (Thomas Pantzer) 
 * 
 */




#ifndef _NETUTILS_H
#define _NETUTILS_H


#include <netinet/in.h>
#include <sys/socket.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <netdb.h>

#ifndef _MY_PORTNUM   
// this number might be overridden by an entry for service "webcamd" to /etc/services 
#define _MY_PORTNUM	34567
#endif

#ifndef LINGER_TIMEOUT
#ifdef sun
  #define LINGER_TIMEOUT	60	// 60 seconds
#else  
#endif
#endif


extern int GetTCPPort(char proto[64]);
extern void hostname_str(struct sockaddr_in *client,char *result);
extern void ShutDown(int sd);	// extra strong linger shutdown sequence 
extern int clConnect_to(char *, int);
extern int svListen(int);
extern int svAccept(int);
//extern void SendMsg(int, char *);

#endif
