/* 
 * Thomas Pantzer: xcap.cc, v0.1b  28.1.98 18:6 
 * 
 * 
 * Copyright 1998 by Thomas Pantzer
 * 
 * Permission to use, copy, modify, and distribute this software for noncommercial 
 * use and without fee is hereby granted, provided that the above copyright notice 
 * appear in all copies and that both that copyright notice and this permission 
 * notice appear in supporting documentation, and that the name of the Author not be 
 * used in advertising or publicity pertaining to distribution of the software 
 * without specific, written prior permission. The Author makes no representations about
 * the suitability of this software for any purpose.  It is provided "as is" 
 * without expressed or implied warranty. 
 * 
 * 
 * pantec@aix520.informatik.uni-leipzig.de   (Thomas Pantzer) 
 * 
 */

/* Form definition file generated with fdesign. */

#include "forms.h"
#include <stdlib.h>
#include "xcap.h"

#include "tuner.xbm"
#include "svhs.xbm"
#include "video.xbm"

FD_xcap *create_form_xcap(void)
{
  FL_OBJECT *obj;
  FD_xcap *fdui = (FD_xcap *) fl_calloc(1, sizeof(*fdui));

  fdui->xcap = fl_bgn_form(FL_FLAT_BOX, 400, 300);
//  obj = fl_add_box(FL_UP_BOX,0,0,640,310,"");
  fdui->canvas = obj = fl_add_canvas(FL_NORMAL_CANVAS,5,5,390,290,"");
    fl_set_object_boxtype(obj,FL_DOWN_BOX); 
  fl_end_form();
  
  return fdui;
}

FD_xcontrol *create_form_xcontrol(void)
{
  FL_OBJECT *obj;
  FD_xcontrol *fdui = (FD_xcontrol *) fl_calloc(1, sizeof(*fdui));

  fdui->xcontrol = fl_bgn_form(FL_NO_BOX, 240, 310);
  obj = fl_add_box(FL_UP_BOX,0,0,240,310,"");
  
  fdui->exit_bt = obj = fl_add_button(FL_NORMAL_BUTTON,170,10,50,30,"Exit");
    fl_set_button_shortcut(obj,"x",1);
    fl_set_object_callback(obj,button_cb,-1);
 
  fdui->gmode_ch = obj = fl_add_choice(FL_NORMAL_CHOICE,20,10,60,30,"Graphic Mode");
    fl_set_object_boxtype(obj,FL_RSHADOW_BOX); 
//    fl_set_object_boxtype(obj,FL_DOWN_BOX); 
//    fl_addto_choice(obj,"static gray|grayscale|static color|pseudo color|true color|direct color");
    fl_set_object_callback(obj,choice_cb,0);
    fl_set_object_lalign(obj,FL_ALIGN_BOTTOM);

  fdui->vnorm_ch = obj = fl_add_choice(FL_NORMAL_CHOICE,90,10,60,30,"Video Standard");
    fl_set_object_boxtype(obj,FL_RSHADOW_BOX); 
    fl_addto_choice(obj,"PAL|NTSC|SECAM");
    fl_set_object_callback(obj,choice_cb,1);
    fl_set_object_lalign(obj,FL_ALIGN_BOTTOM);


  fdui->inputs = fl_bgn_group();
  fdui->tuner_bt = obj = fl_add_bitmapbutton(FL_RADIO_BUTTON,20,60,50,30,"Tuner");
    fl_set_button_shortcut(obj,"T",1);
    fl_set_object_callback(obj,button_cb,0);
    fl_set_bitmapbutton_data(obj,tuner_width,tuner_height,tuner_bits);
  fdui->video_bt = obj = fl_add_bitmapbutton(FL_RADIO_BUTTON,70,60,50,30,"Video");
    fl_set_button_shortcut(obj,"V",1);
    fl_set_object_color(obj,FL_COL1,FL_RED);
    fl_set_object_callback(obj,button_cb,1);
    fl_set_bitmapbutton_data(obj,video_width,video_height,video_bits);
  fdui->svhs1_bt = obj = fl_add_bitmapbutton(FL_RADIO_BUTTON,120,60,50,30,"Comp");
    fl_set_button_shortcut(obj,"C",1);
    fl_set_object_color(obj,FL_COL1,FL_PALEGREEN);
    fl_set_object_callback(obj,button_cb,2);
    fl_set_bitmapbutton_data(obj,video_width,video_height,video_bits);
  fdui->svhs2_bt = obj = fl_add_bitmapbutton(FL_RADIO_BUTTON,170,60,50,30,"S-VHS");
    fl_set_button_shortcut(obj,"S",1);
    fl_set_object_color(obj,FL_COL1,FL_PALEGREEN);
    fl_set_object_callback(obj,button_cb,3);
    fl_set_bitmapbutton_data(obj,svhs_width,svhs_height,svhs_bits);
  fl_end_group();


  fdui->bands = fl_bgn_group();
  fdui->band1_bt = obj = fl_add_checkbutton(FL_RADIO_BUTTON,20,110,70,20,"Band I");
    fl_set_object_callback(obj,button_cb,4);
  fdui->band3_bt = obj = fl_add_checkbutton(FL_RADIO_BUTTON,20,130,70,20,"Band III");
    fl_set_object_callback(obj,button_cb,5);
  fdui->band4_bt = obj = fl_add_checkbutton(FL_RADIO_BUTTON,20,150,70,20,"Band IV");
    fl_set_object_callback(obj,button_cb,6);
  fl_end_group();


  fdui->chup_bt = obj = fl_add_checkbutton(FL_TOUCH_BUTTON,20,180,70,20,"up");
    fl_set_object_callback(obj,button_cb,7);
  fdui->chdown_bt = obj = fl_add_checkbutton(FL_TOUCH_BUTTON,20,200,70,20,"down");
    fl_set_object_callback(obj,button_cb,8);


  fdui->fps_inp = obj = fl_add_box(FL_NORMAL_TEXT,20,230,70,20,"");
//    fl_set_object_callback(obj,button_cb,8);
    fl_set_object_boxtype(obj,FL_FRAME_BOX);
    fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
//    fl_deactivate_object(obj);


  fdui->colors = fl_bgn_group();
  fdui->brite_sl = obj = fl_add_valslider(FL_VERT_NICE_SLIDER,110,110,25,100,"Bright");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_color(obj,FL_COL1,FL_DARKORANGE);
    fl_set_object_lsize(obj,FL_TINY_SIZE);
    fl_set_slider_precision(obj,0);
    fl_set_object_callback(obj,slider_cb,0);
//    fl_set_slider_value(obj, 0.38);
    fl_set_slider_bounds(obj,-127.0,127.0);
    fl_set_slider_return(obj, FL_RETURN_CHANGED);

  fdui->hue_sl = obj = fl_add_valslider(FL_VERT_NICE_SLIDER,140,110,25,100,"Hue");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_color(obj,FL_COL1,FL_DARKORANGE);
    fl_set_object_lsize(obj,FL_TINY_SIZE);
    fl_set_slider_precision(obj,0);
    fl_set_object_callback(obj,slider_cb,1);
//    fl_set_slider_value(obj, 0.82);
    fl_set_slider_bounds(obj,-127.0,127.0);
    fl_set_slider_return(obj, FL_RETURN_CHANGED);

  fdui->color_sl = obj = fl_add_valslider(FL_VERT_NICE_SLIDER,170,110,25,100,"Color");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_color(obj,FL_COL1,FL_DARKORANGE);
    fl_set_object_lsize(obj,FL_TINY_SIZE);
    fl_set_slider_precision(obj,0);
    fl_set_object_callback(obj,slider_cb,2);
//    fl_set_slider_value(obj, 0.27);
    fl_set_slider_bounds(obj,0.0,511.0);
    fl_set_slider_return(obj, FL_RETURN_CHANGED);

  fdui->contrast_sl = obj = fl_add_valslider(FL_VERT_NICE_SLIDER,200,110,25,100,"Contrast");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_color(obj,FL_COL1,FL_DARKORANGE);
    fl_set_object_lsize(obj,FL_TINY_SIZE);
    fl_set_slider_precision(obj,0);
    fl_set_object_callback(obj,slider_cb,3);
//    fl_set_slider_value(obj, 0.71);
    fl_set_slider_bounds(obj,0.0,511.0);
    fl_set_slider_return(obj, FL_RETURN_CHANGED);

  fl_end_group();


  fdui->freqs = fl_bgn_group();
  fdui->freq_sl = obj = fl_add_valslider(FL_HOR_NICE_SLIDER,30,250,190,20,"Frequency");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_color(obj,FL_COL1,FL_DOGERBLUE);
    fl_set_object_lsize(obj,FL_DEFAULT_SIZE);
    fl_set_object_lalign(obj,FL_ALIGN_TOP);
    fl_set_object_callback(obj,slider_cb,4);
    fl_set_slider_bounds(obj,48.0,63.0);
    fl_set_slider_value(obj, 50.25);
    fl_set_slider_return(obj, FL_RETURN_CHANGED);
    fl_set_slider_step(obj, 7.0);

  fdui->finefrq_sl = obj = fl_add_valslider(FL_HOR_NICE_SLIDER,30,270,190,20,"Adjust");
    fl_set_object_boxtype(obj,FL_FLAT_BOX);
    fl_set_object_color(obj,FL_COL1,FL_DOGERBLUE);
    fl_set_object_lsize(obj,FL_DEFAULT_SIZE);
    fl_set_object_callback(obj,slider_cb,5);
    fl_set_slider_bounds(obj,-4.0,4.0);
    fl_set_slider_step(obj,0.0625);
    fl_set_slider_value(obj, 0.0);
    fl_set_slider_return(obj, FL_RETURN_CHANGED);

  fl_end_group();

  fl_end_form();

  return fdui;
}
/*---------------------------------------*/

