/* 
 * Thomas Pantzer: xcap.h, v0.1b  28.1.98 18:6 
 * 
 * 
 * Copyright 1998 by Thomas Pantzer
 * 
 * Permission to use, copy, modify, and distribute this software for noncommercial 
 * use and without fee is hereby granted, provided that the above copyright notice 
 * appear in all copies and that both that copyright notice and this permission 
 * notice appear in supporting documentation, and that the name of the Author not be 
 * used in advertising or publicity pertaining to distribution of the software 
 * without specific, written prior permission. The Author makes no representations about
 * the suitability of this software for any purpose.  It is provided "as is" 
 * without expressed or implied warranty. 
 * 
 * 
 * pantec@aix520.informatik.uni-leipzig.de   (Thomas Pantzer) 
 * 
 */

#ifndef FD_xcap_h_
#define FD_xcap_h_
/* Header file generated with fdesign. */

/**** Callback routines ****/

extern void button_cb(FL_OBJECT *, long);
extern void slider_cb(FL_OBJECT *, long);
extern void choice_cb(FL_OBJECT *, long);

extern int idle_cb(XEvent *,void *);
extern int nothing_cb(XEvent *,void *);

extern int preemptive_handler(FL_OBJECT *ob, int event,
                          FL_Coord mx, FL_Coord my, int key, void *xev);

// int canvas_expose(FL_OBJECT *ob, Window win, int w, int h, XEvent *ev, void *d);
int canvas_but(FL_OBJECT *ob, Window win, int w, int h, XEvent *ev, void *d);

/**** Forms and Objects ****/
typedef struct {
        FL_FORM *xcap;
        FL_OBJECT *canvas;
        void *vdata;
	long ldata;
} FD_xcap;

typedef struct {
	FL_FORM *xcontrol;

	FL_OBJECT *exit_bt;
	FL_OBJECT *inputs;
	FL_OBJECT *tuner_bt;
	FL_OBJECT *video_bt;
	FL_OBJECT *svhs1_bt;
	FL_OBJECT *svhs2_bt;
	FL_OBJECT *bands;
	FL_OBJECT *band1_bt;
	FL_OBJECT *band3_bt;
	FL_OBJECT *band4_bt;

	FL_OBJECT *chup_bt;
	FL_OBJECT *chdown_bt;
        FL_OBJECT *fps_inp;

	FL_OBJECT *colors;
	FL_OBJECT *brite_sl;
	FL_OBJECT *hue_sl;
	FL_OBJECT *color_sl;
	FL_OBJECT *contrast_sl;
	FL_OBJECT *freqs;
	FL_OBJECT *freq_sl;
	FL_OBJECT *finefrq_sl;
//        FL_OBJECT *canvas;

        FL_OBJECT *gmode_ch;
        FL_OBJECT *vnorm_ch;
	void *vdata;
	long ldata;
} FD_xcontrol;

extern FD_xcap * create_form_xcap(void);
extern FD_xcontrol * create_form_xcontrol(void);

#ifdef MAIN_G
#define vextern
#else
#define vextern extern
#endif

vextern   FD_xcap *fd_xcap;
vextern   FD_xcontrol *fd_xcontrol;

vextern   GC 	canvasGC;
vextern   Window win;
vextern   Display *disp;
vextern   long seconds;
vextern   long pic_num;

#endif /* FD_xcap_h_ */
