/* 
 * Thomas Pantzer: xcap_main.cc, v0.1b  28.1.98 18:6 
 * 
 * 
 * Copyright 1998 by Thomas Pantzer
 * 
 * Permission to use, copy, modify, and distribute this software for noncommercial 
 * use and without fee is hereby granted, provided that the above copyright notice 
 * appear in all copies and that both that copyright notice and this permission 
 * notice appear in supporting documentation, and that the name of the Author not be 
 * used in advertising or publicity pertaining to distribution of the software 
 * without specific, written prior permission. The Author makes no representations about
 * the suitability of this software for any purpose.  It is provided "as is" 
 * without expressed or implied warranty. 
 * 
 * 
 * pantec@aix520.informatik.uni-leipzig.de   (Thomas Pantzer) 
 * 
 */




#include "forms.h"

#define MAIN_G
#include "xcap.h"
#include "capture.h"


int main(int argc, char *argv[])
{
   int i,j;

   fl_initialize(&argc, argv, 0, 0, 0);
   fd_xcap = create_form_xcap();
   fd_xcontrol = create_form_xcontrol();
//   fl_set_color_leak(1);
   
   /* fill-in form initialization code */
//   xcap_init();
   wtw_bpp = xcap_init();

   Size = 0; 

   if ((wtw_bpp < 1) || (wtw_bpp > 3))
      {
       fprintf(stderr,"cannot query display depth (%d)\n",wtw_bpp);
       exit(1);
      } 

#ifdef DEBUG
   fprintf(stderr,"wtw.bpp %d\n",wtw_bpp);
#endif      
      

   if (wtw_bpp == 1)
      {
       int db = 0;
   
       visual_mode = 1;
       
       
       if (argc > 1) 
         if (sscanf(argv[1],"-v%d",&j) == 1)
           visual_mode = j; 

       if (argc > 2) 
         if (sscanf(argv[2],"-v%d",&j) == 1)
           visual_mode = j; 

       if (argc > 3) 
         if (sscanf(argv[3],"-v%d",&j) == 1)
           visual_mode = j; 
   
       fl_set_graphics_mode (gmode[visual_mode].mode, db);
//       fl_set_canvas_visual(fd_xcap->canvas,fl_state[i].xvinfo->visual); 
      } 
      
   /* show the first form */
   fl_set_object_prehandler(fd_xcap->canvas,preemptive_handler);
//    fl_add_canvas_handler(fd_xcap->canvas, Expose, canvas_expose, fd_xcap);
   fl_add_canvas_handler(fd_xcap->canvas, ButtonPress, canvas_but,fd_xcap);
//   fl_show_form(fd_xcontrol->xcontrol,FL_PLACE_FREE,FL_FULLBORDER,"xcap control");

   int port = 4321;
   char host[256] = "robot.informatik.uni-leipzig.de";
   char st[256];
   
   if (argc > 1)
       if (sscanf(argv[1],"-p%d",&i) == 1)
          port = i;
      
   if (argc > 2)
       if (sscanf(argv[2],"-p%d",&i) == 1)
          port = i;
      
   if (argc > 3)
       if (sscanf(argv[3],"-p%d",&i) == 1)
          port = i;
      
   if (argc > 1)
       if (sscanf(argv[1],"-h%s",&st[0]) == 1)
          strcpy(host,st);
      
   if (argc > 2)
       if (sscanf(argv[2],"-h%s",&st[0]) == 1)
          strcpy(host,st);
      
   if (argc > 3)
       if (sscanf(argv[3],"-h%s",&st[0]) == 1)
          strcpy(host,st);
      
   xcap_open(wtw_bpp,host,port);

//   fl_show_form(fd_xcap->xcap,FL_PLACE_MOUSE,FL_TRANSIENT,"xcap");
   
   i = 0;
   while (SizeMode[i].id != 0)
     {
      fl_addto_choice(fd_xcontrol->gmode_ch,SizeMode[i].name);
      i++;
//      fprintf(stderr,"addto %d\n",i);
     } 

//   fl_hide_form(fd_xcontrol->xcontrol);
   // ,FL_PLACE_FREE,FL_FULLBORDER,"xcap control");


   while (true)
     fl_do_forms();

   xcap_exit();
}
