/* 
 * Thomas Pantzer: netutils.cc, v0.1b  23.4.98 14:36 
 * 
 * 
 * Copyright 1998 by Thomas Pantzer
 * 
 * Permission to use, copy, modify, and distribute this software for noncommercial 
 * use and without fee is hereby granted, provided that the above copyright notice 
 * appear in all copies and that both that copyright notice and this permission 
 * notice appear in supporting documentation, and that the name of the Author not be 
 * used in advertising or publicity pertaining to distribution of the software 
 * without specific, written prior permission. The Author makes no representations about
 * the suitability of this software for any purpose.  It is provided "as is" 
 * without expressed or implied warranty. 
 * 
 * 
 * pantec@aix520.informatik.uni-leipzig.de   (Thomas Pantzer) 
 * 
 */




#include "netutils.h"
#include "utils.h"



void hostname_str(struct sockaddr_in *Client,char *result)
{
  unsigned long int i,j;
  unsigned char k,l,m,n;
  char st[256],st2[256];
  struct hostent *remote;

  i=Client->sin_addr.s_addr / 65536;
  j=Client->sin_addr.s_addr % 65536;
  k=i / 256;
  l=i % 256;
  m=j / 256;
  n=j % 256;
  
//  sprintf(result,"%d.%d.%d.%d",n,m,l,k);

  sprintf(st,"%d.%d.%d.%d",n,m,l,k);

#ifdef DEBUG  
  fprintf(stderr,"remote address: %s\n",st); 
  fprintf(stderr,"remote port: %d\n",Client->sin_port);
#endif  

  sprintf(st2,"%c%c%c%c",n,m,l,k);
  remote = gethostbyaddr(st2,strlen(st2),AF_INET); 
  if (remote == NULL)
     {
      herror("gethostbyaddr");
      sprintf(result,"%s:%d",st,Client->sin_port);
     } 
   else  
     {
#ifdef DEBUG
      fprintf(stderr,"remote name: %s\n",remote->h_name);
#endif      
      sprintf(result,"%s:%d",remote->h_name,Client->sin_port);
     } 
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// zum bestimmen der Portnummer aus /etc/services (falls vorhanden)
//________________________________________________________________
int GetTCPPort(char proto[64])
{
  struct servent *MyService;

  MyService = getservbyname(proto,"tcp");

  if (MyService != NULL)
       {
        printf("using port %d from default service for %s\n",
                  ntohs(MyService->s_port),MyService->s_name);
        return ntohs(MyService->s_port);  
       } 
     else 
       return _MY_PORTNUM;
}  



void ShutDown(int sd)
{
   struct linger L;

   fcntl(sd,F_SETFL,O_NONBLOCK);  // get it faster to shut up

   L.l_onoff = 1;
   L.l_linger = LINGER_TIMEOUT;    // measured in 1/100-th of a second
   
   if (setsockopt(sd,SOL_SOCKET,SO_LINGER,&L,sizeof(struct linger)) == -1)
      ErrorMsg("setsockopt()");  

   shutdown(sd,2);
}
