/* 
 * Thomas Pantzer: ppmcompress.cc, v0.1b  23.4.98 14:36 
 * 
 * 
 * Copyright 1998 by Thomas Pantzer
 * 
 * Permission to use, copy, modify, and distribute this software for noncommercial 
 * use and without fee is hereby granted, provided that the above copyright notice 
 * appear in all copies and that both that copyright notice and this permission 
 * notice appear in supporting documentation, and that the name of the Author not be 
 * used in advertising or publicity pertaining to distribution of the software 
 * without specific, written prior permission. The Author makes no representations about
 * the suitability of this software for any purpose.  It is provided "as is" 
 * without expressed or implied warranty. 
 * 
 * 
 * pantec@aix520.informatik.uni-leipzig.de   (Thomas Pantzer) 
 * 
 */







#include "ppmcompress.h"
#include "capture.h"

FILE *write_stdout (void)
{
  FILE * output_file = stdout;

#ifdef USE_SETMODE		/* need to hack file mode? */
  setmode(fileno(stdout), O_BINARY);
#endif
#ifdef USE_FDOPEN		/* need to re-open in binary mode? */
  if ((output_file = fdopen(fileno(stdout), WRITE_BINARY)) == NULL) {
    fprintf(stderr, "Cannot reopen stdout\n");
    exit(EXIT_FAILURE);
  }
#endif
  return output_file;
}

METHODDEF(void)
my_error_exit (j_common_ptr cinfo)
{
	xcap_exit();
}

jpeg_compress_struct *init_jpeg(int W, int H, int B, int quality, int smooth, J_DCT_METHOD method)
{
   jpeg_compress_struct	*jcs;
//   FILE *outf; 
   
   jcs = new jpeg_compress_struct;

   jcs->err = jpeg_std_error(&JE); 
   JE.error_exit = my_error_exit;

   jpeg_create_compress(jcs);
  
//   outf = write_stdout();
     
   jpeg_stdio_dest(jcs, stdout);
   
   // parameters
   jcs->image_width = W;
   jcs->image_height = H;
   jcs->input_components = B;
   
   if (B == 3)
      jcs->in_color_space = JCS_RGB;
    else
      jcs->in_color_space = JCS_GRAYSCALE;

   jpeg_set_defaults(jcs);
//   jcs->dct_method = JDCT_ISLOW;
//   jcs->dct_method = JDCT_IFAST;
   jcs->dct_method = method;
   jcs->smoothing_factor = smooth;

   /* Change scale factor in case -qtables is present. */
//   q_scale_factor = jpeg_quality_scaling(quality);
   
   jpeg_set_quality(jcs, quality, FALSE);

//   jpeg_start_compress(jcs,TRUE);
   
   return jcs;
}


void do_compress(jpeg_compress_struct *jcs, unsigned char *image_buffer)
{    
   JSAMPROW 		row_pointer[1];
   int			row_stride;
   
   row_stride = jcs->image_width * jcs->input_components;
   
   while (jcs->next_scanline < jcs->image_height) 
     {
      row_pointer[0]  = & image_buffer[jcs->next_scanline * row_stride];
      jpeg_write_scanlines(jcs,row_pointer,1);
     }
}     
   

void done_jpeg(jpeg_compress_struct *jcs)
{   
//   jpeg_finish_compress(jcs);    
   jpeg_destroy_compress(jcs);
} 


  
